@echo off
echo -------------------------------------------
echo The Offline Compiler installer for the mbed
echo Builds with the Sourcery chain as well as
echo the gcc4mbed project that Adam Green has
echo so kindly shared. I'll pause a moment when
echo going through steps so you can see what is
echo going on. No interaction is needed from
echo you. When completed, you should have a full
echo offline compiler to play with. See samples
echo for how to set up for offline compile. 
echo -------------------------------------------
choice /c:qw /d:q /t:15 > NUL

echo -------------------------------------------
echo Setting up my path, and a temp folder...
echo -------------------------------------------
choice /c:qw /d:q /t:2 > NUL
set path=%~dp0bin;%PATH%
mkdir temp
cd temp
echo Done.

echo -------------------------------------------
echo Downloading Sourcery and GCC4MBED...
echo -------------------------------------------
choice /c:qw /d:q /t:3 > NUL
wget --no-check-certificate https://sourcery.mentor.com/sgpp/lite/arm/portal/package8735/public/arm-none-eabi/arm-2011.03-42-arm-none-eabi-i686-mingw32.tar.bz2
wget --no-check-certificate https://nodeload.github.com/adamgreen/gcc4mbed/zipball/master
echo Done.

echo -------------------------------------------
echo Now to get everything out...
echo Big one first...
echo -------------------------------------------
choice /c:qw /d:q /t:3 > NUL
7za x -y arm-2011.03-42-arm-none-eabi-i686-mingw32.tar.bz2
7za x -y arm-2011.03-42-arm-none-eabi-i686-mingw32.tar
xcopy /E/H/R/Y arm-2011.03\*.* ..\
echo Done.

echo -------------------------------------------
echo Little one last...
echo -------------------------------------------
choice /c:qw /d:q /t:3 > NUL
rename master gcc4mbed.zip
7za x gcc4mbed.zip 
cd adam*
xcopy /E/H/R *.* ..\..\
cd ..\..\
echo Done.

echo -------------------------------------------
echo Clean out all the temp file stuff...
echo -------------------------------------------
choice /c:qw /d:q /t:2 > NUL
rmdir /q/s temp
echo Done.

echo -------------------------------------------
echo Fix symlink breaks...
echo -------------------------------------------
choice /c:qw /d:q /t:2 > NUL
cd arm-none-eabi
mkdir temp
copy bin\*.exe temp\
cd temp
rename ar.exe arm-none-eabi-ar.exe
rename as.exe arm-none-eabi-as.exe
rename c++.exe arm-none-eabi-c++.exe
rename g++.exe arm-none-eabi-g++.exe
rename gcc.exe arm-none-eabi-gcc.exe
rename ld.exe arm-none-eabi-ld.exe
rename nm.exe arm-none-eabi-nm.exe
rename objcopy.exe arm-none-eabi-objcopy.exe
rename objdump.exe arm-none-eabi-objdump.exe
rename ranlib.exe arm-none-eabi-ranlib.exe
rename strip.exe arm-none-eabi-strip.exe
xcopy /E/H/R/Y *.* ..\..\bin\
cd ..\..\bin\
xcopy /Y arm-none-eabi-c++.exe arm-none-eabi-g++.exe
xcopy /Y arm-none-eabi-gcc.exe arm-none-eabi-gcc-4.5.2.exe
cd ..\arm-none-eabi
rmdir /S/Q temp
cd lib
xcopy /Y libstdc++.a libc.a
cd armv6-m
xcopy /Y libstdc++.a libc.a
cd ..\thumb
xcopy /Y libstdc++.a libc.a
cd ..\thumb2
xcopy /Y libstdc++.a libc.a
cd ..\..\..\
echo Done.

echo -------------------------------------------
echo Performing install build...
echo -------------------------------------------
choice /c:qw /d:q /t:2 > NUL
set PATH=%~dp0arm-none-eabi\bin;%PATH%
cs-make install_mbed
echo Done.

echo -------------------------------------------
echo Creating a shortcut for cs-make...
echo -------------------------------------------
choice /c:qw /d:q /t:2 > NUL
cd bin
echo @echo off > make.bat
echo cs-make %%* >> make.bat
echo Done.
cd ..

echo -------------------------------------------
echo Renaming myself so I'm accident prone...
echo -------------------------------------------
choice /c:qw /d:q /t:2 > NUL
rename createcompiler.cmd createcompiler.cmd.used
echo ----------------All Done!------------------
choice /c:qw /d:q /t:2 > NUL
pause
